  Preface

   This is the Changelog for Apache Tomcat Connectors. This changelog does
   not contain all updates and fixes to the Tomcat connectors (yet). It
   should contain fixes made only after November 10th 2004, when the new
   documentation project for JK was started.

  Changes between 1.2.49 and 1.2.50

    Apache

     * Fix: 68117: Fix typo in new libtool flag introduced in 1.2.49 to
       reduce symbol visibility. Also improve escaping of it in the Makefile.
       Patch provided by lzsiga@freemail.c3.hu. (rjung)
     * Fix: Improve shared memory handling on non-Windows. (rjung)

    IIS

     * Update: Update PCRE bundled with the ISAPI redirector to 8.45. (rjung)

    Common

     * Fix: #8: Fix compilation on musl. Patch provided by
       conrad+github@kostecki.com. (rjung)
     * Update: Update config.guess and config.sub from
       https://git.savannah.gnu.org/git/config.git. (rjung)

  Changes between 1.2.48 and 1.2.49

    Apache

     * Update: Retrieve default request id from mod_unique_id. It can also be
       taken from an arbitrary environment variable by configuring
       "JkRequestIdIndicator". (rjung)
     * Fix: 65901: Don't delegate the generatation of the response body to
       httpd when the status code represents an error if the request used the
       HEAD method. (markt)
     * Fix: 66005: Only export the main module symbol. Visibility of module
       internal symbols led to crashes when conflicting with library symbols.
       Based on a patch provided by Josef Čejka. (rjung)
     * Fix: Remove support for implicit mapping of requests to workers. All
       mappings must now be explicit. (rjung)

    IIS

     * Update: Set default request id as a GUID. It can also be taken from an
       arbitrary request header by configuring "request_id_header". (rjung)
     * Fix: Fix non-empty check for the Translate header. (rjung)

    Common

     * Fix: Fix compiler warning when initializing and copying fixed length
       strings. (rjung)
     * Update: Add a request id to mod_jk log lines. (rjung)
     * Fix: 64878: Enable configure to find the correct sizes for pid_t and
       pthread_t when building on MacOS. (markt)
     * Fix: Fix Clang 15/16 compatability. Pull request #6 provided by Sam
       James. (markt)
     * Update: Improve XSS hardening in status worker. (rjung)
     * Update: Add additional bounds and error checking when reading AJP
       messages. (schultz/markt)

    Docs

     * Update: Remove support for the Netscape / Sun ONE / Oracle iPlanet Web
       Server as the product has been retired. (markt)
     * Update: Remove links to the old JK2 documentation. The JK2
       documentation is still available, it is just no longer linked from the
       current JK documentation. (markt)
     * Update: Restructure subsections in changelog starting with version
       1.2.45. (rjung)

  Changes between 1.2.47 and 1.2.48

    IIS

     * Update: Update the installation how-to to remove windows versions that
       are no longer supported and to add Windows Server 2019. (markt)

  Changes between 1.2.46 and 1.2.47

    Apache

     * Add: Extend trace level logging of method entry/exit to aid debugging
       of request mapping issues. (markt)
     * Fix: Fix a bug in the normalization checks that prevented file based
       requests, such as SSI file includes, from being processed. (markt)
     * Fix: 63214: When using JkAutoAlias, ensure that files that include
       spaces in their name are accessible. (markt)

    Common

     * Update: Update the documentation to reflect that the source code for
       the Apache Tomcat Connectors has moved from Subversion to Git. (markt)
     * Fix: 64051: When using set_session_cookie, ensure that an updated
       session cookie is issued if the load-balancer has to failover to a
       different worker. (markt)
     * Update: Update config.guess and config.sub from
       https://git.savannah.gnu.org/git/config.git. (markt)
     * Update: Update release script for migration to git. (rjung)

  Changes between 1.2.45 and 1.2.46

    Apache

     * Fix: 62751: Fix regression in 1.2.44 which resulted in
       socket_connect_timeout to be interpreted in units of seconds instead
       of milliseconds on platforms that provide poll(). (rjung)

  Changes between 1.2.44 and 1.2.45

    Apache

     * Update: Update the documentation to note additional limitations of the
       JkAutoAlias directive. (markt)
     * Fix: Improve path parameter handling so that JkStripSession can remove
       session IDs that are specified on path parameters in any segment of
       the URI rather than only the final segment. (markt)

    IIS

     * Fix: Improve path parameter handling so that strip_session can remove
       session IDs that are specified on path parameters in any segment of
       the URI rather than only the final segment. (markt)

    Common

     * Fix: 62689: Correct regression in 1.2.44 that broke request handling
       for OPTIONS * requests. (rjung)
     * Code: Optimize path parameter handling. (rjung)
     * Fix: Improve path parameter parsing so that the session ID specified
       by the session_path worker property for load-balanced workers can be
       extracted from a path parameter in any segment of the URI, rather than
       only from the final segment. (markt)

  Changes between 1.2.43 and 1.2.44

    Native

     * Update: Remove the Novell Netware make files and Netware specific
       source code since there has not been a supported version of Netware
       available for over five years. (markt)
     * Update: 57946: Apache: Update the documentation to use httpd 2.4.x
       style access control directives. (markt)
     * Fix: 58287: Common: Use Local, rather than Global, mutexs on Windows
       to better support multi-user environments. (markt)
     * Fix: 59897: Apache: Use poll rather than select to avoid the
       limitations of select triggering an httpd crash. Patch provided by
       Koen Wilde. (markt)
     * Fix: 60745: ISAPI: Remove the check that rejects requests that contain
       path segments that match WEB-INF or META-INF as it duplicates a check
       that Tomcat performs and, because ISAPI does not have visibility of
       the current context path, it is impossible to implement this check
       without valid requests being rejected. (markt)
     * Add: Clarify the behvaiour of lb workers when all ajp13 workers fail
       with particular reference to the role of the retries attribute.
       (markt)
     * Add: 62408: Add the new load-balancer worker property lb_retries to
       improve the control over the number of retries. Based on a patch
       provided by Frederik Nosi. (markt)
     * Fix: Refactor normalisation of request URIs to a common location and
       align the normalisation implementation for mod_jk with that
       implemented by Tomcat. (markt)
     * Add: Add a note to the documentation that the CollapseSlashes options
       are now effectively hard-coded to CollpaseSlashesAll due to the
       changes made to align normalization with that implemented in Tomcat.
       (markt)
     * Update: Update PCRE bundled with the ISAPI redirector to 8.42. (rjung)
     * Update: Update config.guess and config.sub from
       https://git.savannah.gnu.org/git/config.git. (rjung)

  Changes between 1.2.42 and 1.2.43

    Native

     * Fix: 61733: LB: Propagate load factor changes applied by the status
       worker to a load balancer sub worker correctly to all processes. Based
       on a patch provided by Jonathan Oddy. (rjung)
     * Fix: ISAPI: Align the make files for 32-bit and 64-bit builds. (markt)
     * Update: Update config.guess and config.sub from
       http://git.savannah.gnu.org/cgit/config.git. (rjung)
     * Update: Update PCRE bundled with the ISAPI redirector to 8.41. (rjung)
     * Fix: Update the ISAPI redirector installation documentation to reflect
       the currently supported versions of Windows. (markt)
     * Fix: Align the normalization performed by the ISAPI redirector with
       that implemented by Tomcat. (markt)

  Changes between 1.2.41 and 1.2.42

    Native

     * Fix: Status: Fix displayed number of bytes read from and written to
       the backend when an AJP worker is used without a load balancer worker.
       (rjung)
     * Fix: Apache: Don't try to read remaining request body parts during
       clean up if reading the request body from the client already failed
       during earlier processing phases. (rjung)
     * Fix: 57485: Apache: Propagate errors reading the request body from the
       client to mod_jk so Tomcat sees an error rather than a truncated body.
       (markt)
     * Fix: 57836: ISAPI: Empty REMOTE_USER should not be translated to "".
       (rjung)
     * Fix: 58249: Add a note the the documentation that max_packet_size will
       be aligned to the next multiple of 1024 if a value is specified that
       is not a multiple of 1024. (markt)
     * Update: 58309: ISAPI: Update bundled pcre from version 5.0 to 8.38.
       (rjung)
     * Fix: 58286: Fix crash in mod_jk and in the ISAPI Redirector. The crash
       only happens on Windows when retrieving the jk-status for the HTML
       format (which is the default format). This regression was introduced
       by the fix to 54177. (rjung)
     * Fix: 58285: Don't use GCC atomics on platforms, for which GCC doesn't
       provide an atomics implementation. This regression was introduced by
       the fix to 44454 and 56703. (rjung)
     * Fix: 58425: Fix regression in 1.2.41 that prevented AJP 1.2 workers
       from initialising. Note that the AJP 1.2 protocol is deprecated. Patch
       provided by yagisita. (markt)
     * Fix: 58504: If a background thread is used to perform worker
       maintenance, ensure that maintenance runs are not skipped. Patch
       provided by Hiroto Shimizu. (markt)
     * Fix: 58608: ISAPI: Add a new registry option "flush_packets" that
       allows the flushing behaviour of IIS7+ to be controlled. The default
       is not to flush. Setting the option to "true" with cause IIS to write
       data to the client as each AJP packet is received. (markt)
     * Fix: 58813: ISAPI: Correctly release a mutex allowing the plugin to
       complete initialization. Prior to this fix, the incomplete
       initialization was causing a hang on shutdown. Patch provided by
       Matthew Reiter. (markt)
     * Fix: 58895: Correct an off-by-one error in the log messages for the
       number of attempts made to communicate with the backend server. Patch
       provided by Hiroto Shimizu. (markt)
     * Fix: 59164: Fix crash on first connection if a host name is specified
       for the worker that cannot be resolved to an IP address. (markt)
     * Fix: 59184: HTTPD: Avoid segmentation fault if mod_jk is configured
       with an invalid value for JkShmFile. This causes the server startup to
       fail. (markt)
     * Fix: Minor code clean-up and optimization. (markt)

  Changes between 1.2.40 and 1.2.41

    Native

     * Fix: AJP, LB: Reduce lock contention during maintenance function. This
       was observable when using a big number of AJP13 and LB workers,
       especially in combination with the Apache httpd prefork MPM. (rjung)
     * Fix: 57060: Allow building from outside of source tree. Patch
       contributed by Petr Sumbera. (rjung)
     * Fix: 56703: Status: Fix inflated counter for current number of backend
       connections especially when a connection timeout occurred on the
       backend. (rjung)
     * Fix: 56661: Fix Servlet API getLocalAddr(). Works for Tomcat 6.0.42,
       7.0.55 and 8.0.11 and Apache and ISAPI plugins. (rjung)
     * Update: Status: Log old and new values when changing worker
       attributes. (rjung)
     * Fix: 56667: Status: Fix log message when changing activation state of
       all members. (rjung)
     * Fix: 56565: Fix IPV6 address resolve on non-dual network stacks.
       (mturk)
     * Fix: 50511: Reduce log level for "OPTIONS *" requests from warning to
       debug. (rjung)
     * Fix: Apache: Copy log notes instead of using references to prevent
       access to memory from closed pool. (rjung)
     * Add: Add option to control handling of multiple adjacent slashes in
       mount and unmount. New default is collapsing the slashes only in
       unmount. Configuration is done via new JkOption for Apache
       ("CollapseSlashesAll", "CollapseSlashesNone" or
       "CollapseSlashesUnmount") and via property "collapse_slashes" for IIS
       (values "all", "none", "unmount"). This is the fix for CVE-2014-8111.
       (rjung)
     * Add: Add more checks for shared memory allocation. (rjung)
     * Add: 56869: Status: Add maximum number of open backend connections to
       status worker. Patch contributed by Martin Knoblauch. (rjung)
     * Add: 56770: AJP: Add worker name to all log messages. Patch
       contributed by Martin Knoblauch. (rjung)
     * Fix: 50186: Docs: Clarify relation between "connection_pool_timeout"
       and "keepAliveTimeout" or "connectionTimeout" in the Tomcat AJP
       connector configuration. (rjung)
     * Fix: 52334: LB: Calculate worker recovery time based on last recovery
       attempt time instead of original error time after the first recovery
       attempt. (rjung)
     * Fix: 54596 part 1: IIS: Fix missing last character when parsing
       relative file names with no ".." directory components from
       configuration. (rjung)
     * Fix: 54596 part 2: IIS: Fix using relative file names in config with
       ".." path segments that go up the directory hierarchy higher than the
       starting point of the relative file name. (rjung)
     * Fix: Status: Add logging if status worker output was dropped due to
       insufficient buffer size. (rjung)
     * Fix: Reduce log buffer from 8KB to 1KB. Add logging in case of failed
       logging and add trailing "..." to lines which were likely truncated.
       (rjung)
     * Update: Replace fixed allocation of 32 entries for fail_on_status by
       dynamic allocation. (rjung)
     * Add: Enforce implementation restriction on maximal length "60" of
       worker attributes "name", "host", "route", "domain", "redirect",
       "session_cookie", "session_path" and "set_session_cookie". Checks were
       added to configuration file processing and configuration updates via
       the status worker. (rjung)
     * Add: 52483: Apache: Add debug logging for result of JkOptions
       configuration processing. (rjung)
     * Fix: 54177: Status: Use numeric time stamps instead of textual ones to
       avoid non-well-formed XML output. Textual timestamps are formatted
       according to locale settings and reencoding them to UTF-8 would be
       cumbersome. (rjung)
     * Fix: 56618: Status: Use percent decoding when reading query string
       parameters. For example this fixes editing IPv6 addresses via the
       status worker if the client encodes ":" as "%3A". Patch contributed by
       Christopher Schultz. (rjung)
     * Fix: 56452: Fix crash in debug logging for IPv6 adresses. Patch
       contributed by Christopher Schultz. (rjung)
     * Fix: 34526: Apache: Improve compatibility with mod_deflate request
       body inflation. An automatic detection of mod_deflate inflation is not
       implemented. Use the new Apache environment variable JK_IGNORE_CL
       instead, to let mod_jk ignore an existing Content-Length request
       header. (rjung)
     * Update: 44454: LB: Add warning to docs about problems with "busyness"
       load balancing method. (rjung)
     * Fix: 44454: Improve busy counter by using atomics. (rjung)
     * Fix: 56703: Status: Improve connected counter. Use atomics and for
       mod_jk (Apache) currectly count down connections closed by child
       processes that are stopped. (rjung)
     * Fix: 44571: Ensure that we return with status 503 if we can not get
       and endpoint for a worker. (rjung)
     * Fix: Apache: Improve log handling during graceful or normal restart.
       (rjung)
     * Fix: Don't update last access time of worker connections during
       optional checking of idle connections using CPing. Updating the time
       stamp breaks closing idle connections. (rjung)
     * Fix: Adjust linger parameters used during connection shutdown. (rjung)
     * Fix: Fix annoying redefine warnings for the autoconf PACKAGE defines
       during configure based builds. (rjung)
     * Fix: Status: Use multi-line table headers and fix invalid xml output.
       (rjung)
     * Fix: 44571: Implement an optional limit on concurrent requests allowed
       for a worker (attribute "busy_limit"). Original patch contributed by
       zealot0630 at gmail dot com. (rjung)
     * Fix: Correct log message "all endpoints are disconnected" to "no
       usable connection found, will create a new one". Tone done from info
       log level to debug for the common case. (rjung)
     * Add: 57536: AJP: Allow to configure connection source address. This
       should only be used on multi-homed hosts. The feature is experimental.
       (rjung)
     * Add: 57540: AJP: Forward name of SSL protocol used for handling the
       request (SSLv3, TLSv1, TLSv1.1, TLSv1.2). (rjung)

  Changes between 1.2.39 and 1.2.40

    Native

     * Fix: Fix forwarding of chunked requests, which is broken in version
       1.2.39. (rjung)
     * Fix: 56352: Fix regression in memory release. (mturk)
     * Fix: Fix status worker display of worker IP address after name or port
       was changed. (rjung)
     * Update: 56297: Improve key hash function. Copied from APR. (rjung)
     * Fix: 55683: Remove quotes from quoted session cookies. (rjung)
     * Fix: 53542: ISAPI: Fix grammar in 503 error page. (rjung)
     * Fix: 55696: Crash on Mac OS X 10.9 during config parsing. (rjung)

  Changes between 1.2.37 and 1.2.39

    Native

     * Update: Deprecate nt_service from Apache Tomcat Connectors. (mturk)
     * Fix: 56133: Fix possible crash when a request fails during request
       body transfer to the back end and reply_timeout was set. Patch
       contributed by Hiroto Shimizu. (rjung)
     * Fix: Fix status worker not updating parameters for all members.
       (mturk)
     * Fix: 55853: HTTPD: Use the correct API for setting Content-Length.
       Patch contributed by areese yahoo-inc.com. (rjung)
     * Add: Add IPV6 support for connection to webserver. New directive
       prefer_ipv6 has been added to control the hostname resolution and
       preserve backward compatibility. (mturk)
     * Add: Add --disable-sock-cloexec to configure to disable use of
       SOCK_CLOEXEC (using FD_CLOEXEC + fnctl instead) so built modules will
       work with Linux kernels prior to 2.6.27. (timw)
     * Update: Clean up config file parsing. Worker names are now restricted
       to 60 bytes. (rjung)
     * Update: Allow to set a stickyness cookie in case a web framework
       breaks Tomcat's adding of the routing ID to the end of the JSESSIONID
       cookie. (rjung)
     * Update: Use max_packet_size also for request body forwarding. (rjung)
     * Update: Apache 2.4: By default forward logical client address as
       provided by mod_remoteip. When setting JkOptions
       ForwardPhysicalAddress mod_jk will instead forward the physical peer
       address. (rjung)
     * Update: Minor documentation improvements. (rjung)

  Changes between 1.2.36 and 1.2.37

    Native

     * Fix: Fix regression which can crash webserver in case worker is
       defined both as member of load balancer and as standalone worker.
       (mturk)
     * Fix: Fix core if debug log level is specified and there is no session
       identifier present. (mturk)

  Changes between 1.2.35 and 1.2.36

    Native

     * Fix: Use named shared memory objects so that we preserve runtime
       configured data instead of resetting on each child creation. (mturk)
     * Fix: Fix dead-lock caused by not releasing mutex on close. (mturk)
     * Fix: Fix compilation of mod_jk for HTTPD 1.3. (rjung)
     * Fix: 46893: HTTPD 1.3: Apply fix to HTTPD 1.3. It was fixed for HTTPD
       2.x already in version 1.2.30. (rjung)
     * Update: HTTPD 1.3: Allow to set path parameter used when doing
       JkStripSession. This was available for HTTPD 2.x already since mod_jk
       1.2.27. (rjung)

  Changes between 1.2.33 and 1.2.35

    Native

     * Fix: HTTPD: Fix crash on unknown worker names. (mturk)
     * Fix: IIS: Fix crash on worker process recycle. (mturk)
     * Fix: 52659: IIS: Fix shared memory corruption. (mturk)
     * Fix: 52921: HTTPD: Fix crash in uri mapping. (mturk)

  Changes between 1.2.32 and 1.2.33

    Native

     * Fix: 52793: AJP: Fix default value of forwarded worker activation
       state. Contributed by Yoshihito Fukuyama. (rjung)
     * Fix: HTTPD: Improve support for HTTPD 2.4 by using client_* instead of
       remote_* variables. (rjung)
     * Fix: 52564: Fix building with format checking gcc security hardening
       cflags. Contributed by Tony Mancill. (rjung)
     * Fix: 52567: Balancer member in recovery state can switch back into
       error state if it is idle. (rjung)
     * Update: Log error if unable to load URI workermap file, and improve
       logging of unreadable worker files on IIS. (timw)
     * Update: Remove deprecated JNI worker and build dependency on Java SDK.
       (mturk)
     * Fix: 51253: Forward WWW-Authenticate header when using server
       generated error pages (rjung, mturk).
     * Update: 46406: IIS: Support relative paths in configuration. The paths
       are presumed to be relative from isapi_redirect.dll. (mturk)
     * Fix: 50233: Do not use hard limit on uri size (mturk).
     * Update: IIS: Use Windows Server 2003 SP1, Windows XP SP2 as minimal
       version supported. (mturk)
     * Fix: 47038: Fix compiler warning when using --enable-flock for
       configure. (rjung)
     * Add: 51326: URI Map: Add "session_cookie" and "session_path" rule
       extensions. Contributed by Eiji Takahashi. (rjung)
     * Update: 51333: IIS: Document configuration requirement for 64 Bit
       environment. (rjung)
     * Add: 51743: HTTPD: Support rule extensions when defining the request
       worker with an environment variable (e.g. JK_WORKER_NAME). (rjung)
     * Fix: 51769: IIS: Allow URIs which contain "META-INF" or "WEB-INF" as
       long as they are not path components of the URI. (rjung)
     * Fix: 52056: HTTPD: JK request log does not always log correct response
       status. Fixed by refactoring JK request log to use the standard
       request log hook. (rjung)
     * Add: HTTPD: Allow to choose a sticky worker using the environment
       variable JK_ROUTE. This can be used if sessions and routes are send
       with the request in a non-standard way. (rjung)
     * Add: URI Map: Add "sticky_ignore" extension attributes to uri worker
       map. It allows to disable stickyness for individual mounts. (rjung)
     * Add: HTTPD: Allow dynamic disabling of stickyness using the
       environment variable JK_STICKY_IGNORE. This can be useful to break
       cookie stickyness for non-sticky requests like login forms. (rjung)
     * Add: LB: New balancing method "Next" to distribute sessions in a
       round-robin way. (rjung)
     * Add: LB: Add counter for created sessions to status worker and HTTPD
       notes. It actually counts the number of requests that do not carry a
       session id. (rjung)
     * Add: URI Map: Add "stateless" extension attributes to uri worker map.
       This can improve session load balancing. (rjung)
     * Add: HTTPD: Allow dynamic switching of requests to "stateless" using
       the environment variable JK_STATELESS. (rjung)
     * Update: AJP: Improve logging when request does not fit into an AJP
       packet. (rjung)

  Changes between 1.2.31 and 1.2.32

    Native

     * Fix: 51417: Fix worker busy detection by querying the worker endpoint.
       Abandoned connections can leave a worker in busy state without
       decrementing busy counter. (mturk)
     * Fix: 50339: Fix whitespace trimming when parsing attribute lists.
       (rjung)
     * Fix: 41263: Support Servlet API getRemotePort(). Works for Tomcat
       5.5.28, 6.0.20 and 7.0.0 and Apache and ISAPI plugins. (rjung)
     * Fix: 41923: AJP: Close AJP connection to Tomcat on client write error
       when recovery_options 4 is specified, aborting the response write on
       the Tomcat side. (timw)
     * Update: AJP: Cap the lingering bytes that will be read when shutting
       down an AJP socket at 32k to prevent CPU spikes in the web server when
       a client aborts on a large response body. Also reduce total linger
       time to 2s. (timw)
     * Fix: 50839: AJP: Fix 30sec CPU spike due to incorrect counting of
       lingering bytes causing a busy loop when a client aborts connection
       during a response write. Fixes regression in 1.2.31. (timw)
     * Add: LB: Forward worker activation state as request attribute
       "JK_LB_ACTIVATION". Possible values are "ACT" (active), "DIS"
       (disabled) and "STP" (stopped). (rjung)
     * Fix: HTTPD: Forward WWW-Authenticate from backend when status is 401
       and server generated error pages are used. (rjung)
     * Fix: 50363: IIS: Prevent chunk encoding of empty message bodies for
       204, 205 and 304 responses. (timw)
     * Fix: 50975: IIS: Fix hanging of Transfer-Encoding: chunked requests
       when Content-Length header is present in request as well. Also
       addresses situation where IIS appears to create a Content-Length
       header for a small chunk encoded request when none was present in the
       original request. (timw)
     * Fix: 47679: IIS: stop truncation of request headers when ISAPI
       redirector used as an extension without the corresponding filter
       installed. (timw)
     * Fix: NSAPI: Use lower case header names for responses. Otherwise the
       web server might add chunked transfer encoding header in addition to
       our content length header.
     * Update: Docs: Improve load balancer documentation. (rjung)

  Changes between 1.2.30 and 1.2.31

    Native

     * Fix: 49413: AJP13: Drop flush packets send by the backend after the
       response has been finished. (rjung)
     * Update: AJP: Log the local and remote socket address. (mturk)
     * Update: Watchdog: Move the maintain workers outside the critical
       section allowing other threads to use the connection pool during
       maintenance. (mturk)
     * Update: Common: Add svn revision to init log message. (rjung)
     * Fix: Common: Don't destroy errno during trace logging. (rjung)
     * Update: Apache: Add support for Apache 2.3/2.4. (rjung)
     * Update: Apache: Added version number resource for mod_jk.so on
       Windows. (timw)
     * Update: 48501: IIS: Added rotatelogs style log rotation to ISAPI
       Redirector. (timw)
     * Fix: 38895: IIS: Use RAW headers instead of CGI headers by default to
       prevent conversion of underscores '_' to hyphens '-' in header names.
       Old behaviour can be enabled by defining USE_CGI_HEADERS. (timw)
     * Fix: 49511: IIS: Do not override IIS log information when subsequent
       requests on a keep-alive connection are not mapped into the ISAPI
       Redirector. (timw)
     * Fix: Docs: Document SSLOptions needed for SSL information forwarding.
       (rjung)
     * Update: Docs: Grammar and style improvements and clarification about
       serving static content by IIS. Patch provided by André Warnier.
       (rjung)
     * Fix: Docs: Update subversion paths used in docs. (rjung)

  Changes between 1.2.28 and 1.2.30

    Native

     * Update: Apache: Improve compatibility with Apache 2.3. (rjung)
     * Fix: 46632: Apache: Do not register child cleanup for our pools.
       (mturk)
     * Fix: 46893: Apache: Log warning only if JkShmSize was actually set in
       the configuration. (mturk)
     * Update: IIS: Include optional chunking support. Off by default.
       (mturk)
     * Fix: 48763: IIS: Do not send Content-Length when using chunked
       encoding or length larger 4GB. (mturk)
     * Fix: 48223: IIS: Propagate correct backend error code to IIS. (rjung)
     * Fix: 47867: IIS: crash during startup, when compiled with VS2008 and
       workers.properties contains unsupported properties. Patch provided by
       Indrek Juhani (rjung)
     * Fix: 47628: IIS: Fix deadlock when restarting the Application Pool
       caused by not releasing the critical section lock. Patch provided by
       Bret Prucha. (mturk)
     * Fix: IIS/NSAPI: Correct log file flushing after each line. (mturk)
     * Add: NSAPI: Add Microsoft Visual C++ Makefile. (mturk)
     * Update: AJP: Improve socket shutdown handling. (mturk)
     * Update: AJP: Ensure we never reuse a non reusable socket. (mturk)
     * Update: AJP: Tolerate a single excess packet when waiting for cpong.
       (mturk)
     * Update: AJP: Check protocol correctness more strictly. (mturk)
     * Update: 48410: AJP: Use poll instead select so we can work with more
       then 1024 sockets. (mturk)
     * Fix: 46503: AJP/Status: Garbage data in worker domain and route.
       (mturk)
     * Fix: 48276: AJP: When worker contact cannot be resolved mark the
       worker as disabled instead failing to start the server. (mturk)
     * Fix: 48169: AJP: Improve CGI interoperability by closing all sockets
       during EXEC. (mturk)
     * Add: Status: Add number of open backend connections to status worker.
       This feature is experimental, the displayed value might not be
       accurate. (mturk)
     * Update: 47224: Status: When address gets changed invalidate all opened
       sockets in the endpoint cache. This will cause new backend connections
       to get opened using new address. (mturk)
     * Fix: 48305: Status: Do not show "secret" property when doing dump.
       (mturk)
     * Fix: 45610: Status: Don't accept requests with empty value for sub
       worker parameter. (rjung)
     * Fix: 45610: Status: Fix erroneous unsetting of sticky_session and
       sticky_session_force when updating other load balancer attributes via
       the status worker. (rjung)
     * Fix: 47222: Status: Add ping_timeout to the shared memory and allow
       dynamic configuration. (mturk)
     * Fix: Status: Remove duplicate "errors" line in property view of AJP13
       workers that are part of a load balancer. (rjung)
     * Fix: LB: Fix route logging. (rjung)
     * Update: Logging: Automatically detect size of thread id for logging.
       (rjung)
     * Update: Logging: Add optional log file locking for Windows when
       defining JK_LOG_LOCKING. (mturk)
     * Update: Configuration: Update example configuration. (rjung)
     * Update: Docs: Update information about tools needed to create a
       release. (rjung)
     * Fix: 47983: Docs: Fix typo in example config which breaks startup.
       (rjung)
     * Update: Build: Force copy of automake files. (rjung)
     * Update: Build: Tomcat code repository structure cleanup reflected in
       documentation and build script. (rjung, mturk)

  Changes between 1.2.27 and 1.2.28

    Native

     * Add: Apache: Add more environment variables to overwrite request
       information. Useful in case a proxy is in front of Apache and sends us
       original request information e.g. via custom headers. (rjung)
     * Update: Apache: No longer preallocate entries for JK request log.
       (rjung)
     * Fix: 46352: Apache: Fix crash when using SetHandler jakarta-servlet in
       VHost without any JkMount. Crash due to incorrect initialization of
       mount extensions. (rjung)
     * Fix: Apache: JkWatchdogInterval had wrong interval calculation causing
       a 10 times higher watchdog interval then configured. (mturk)
     * Fix: Apache: Activate forwarding of SSL key size by default. (rjung)
     * Fix: 46169: Apache 1.3: Backport use_server_errors mount extension.
       (rjung)
     * Fix: 46763: Apache 2.0: Survive the log mutex during graceful restart.
       Patch provided by Eiji Takahashi. (mturk)
     * Fix: 46416: Apache 2.0 on Windows: Include mstcipip.h even if the apr
       doesn't include it. (mturk)
     * Update: IIS: Update uriworkermap.properties file on a regular
       interval. This requires both worker_mount_reload and watchdog_interval
       to be defined. (mturk)
     * Update: IIS: Remove obsolete entries from registry file. (mturk)
     * Fix: 46579: IIS: Use local environment table instead environment
       variables for setting the JKISAPI_PATH and JKISAPI_NAME. (mturk)
     * Update: LB: Add new property error_escalation_time to fine tune
       escalation of local errors to global errors. (rjung)
     * Update: LB: If the sticky session affinity mark contains a dot, treat
       the part before the dot as the domain name. This allows to have full
       node session affinity with domain failover. (mturk)
     * Fix: LB: make forced recovery work with local error states. (rjung)
     * Fix: LB: Only update error state and error time, if we actually have a
       new state. (rjung)
     * Fix: LB: Set global worker state to error when we reach
       max_reply_timeouts, or fail_on_status triggered hard error. (rjung)
     * Update: AJP: Add a new error type JK_AJP_PROTOCOL_ERROR. (mturk)
     * Update: AJP: Allow worker ports lower or equal to 1024. (rjung)
     * Update: AJP: Improve some AJP error log messages. (mturk)
     * Update: Status: Allow changing worker address and port of AJP workers.
       The address is resolved on next request for that worker. (mturk)
     * Update: Status: Allow update actions to show error messages in the
       result page. (rjung)
     * Update: Status: Refactor update actions. (rjung)
     * Update: Status: Do not redirect to the show or list page, if an error
       occured during an action. (rjung)
     * Update: Status: Include error time in display. (rjung)
     * Update: Status: Remove redundant port information from worker display.
       Rename address column and remove its explanation from the legend.
       (rjung)
     * Update: Status: Optimize forced uriworkermap.properties reload.
       (mturk)
     * Fix: Status: Fix crash in text display. (rjung)
     * Fix: Status: Show - Edit - Show always ends in single lb member show,
       even when started from all members lb show. (rjung)
     * Fix: Status: Wildcards in sub worker names were broken for update
       actions. (rjung)
     * Fix: Status: Add use_server_errors to map display. (rjung)
     * Update: SHM: Move locking into the data pull and push methods. (rjung)
     * Update: JNI: Deprecate JNI workers. (rjung)
     * Fix: Netware: Missing define for MAX_PATH. Patch by Guenter Knauf.
       (rjung)
     * Update: Docs: Add a new HowTo page about reverse proxies. (rjung)
     * Update: Docs: Add an explanation of local error states to the timeouts
       documentation. (rjung)
     * Update: Docs: Clarify relation between socket_timeout and
       socket_connect_timeout. (rjung)
     * Update: Docs: Clarify IIS URL rewrite feature. (rjung)
     * Fix: 46834,46734: Docs: Fix a couple of missing or broken links.
       (markt,rjung)
     * Fix: Docs: Add 2008 news to main page and menues. (mturk, rjung)

  Changes between 1.2.26 and 1.2.27

    Native

     * Fix: 46109: Decay reply_timeouts even when lb method is busyness. Also
       reset reply_timeouts during forced recovery. (rjung)
     * Update: AJP13: Recycle connection if previous request didn't complete.
       (mturk)
     * Update: Maintain should not run multiple times in parallel. (mturk)
     * Fix: Apache: Fix small memory leak during restart. (mturk)
     * Update: Improve signal handling during socket shutdown. (mturk)
     * Add: URI Map: Add debug dump function for uri worker map. (rjung)
     * Update: Add revision number to version info for non-release builds.
       (rjung)
     * Add: IIS: Optionally allow chunked encoding for responses. At the
       moment only usable, if build with ISAPI_ALLOW_CHUNKING defined. Based
       on patch by Tim Whittington. (rjung)
     * Update: IIS: Optionally use raw headers instead of CGI headers. Fixes
       problem "underscore=dash" problem in header names. At the moment only
       available, if build with USE_RAW_HEADERS defined. (rjung)
     * Update: IIS: Optionally improve IIS 5.1 compatibility. At the moment
       only available, if build with AUTOMATIC_AUTH_NOTIFICATION defined.
       Based on patch by Tim Whittington. (rjung)
     * Fix: IIS: Fix memory corruption due to parallel initialization by
       multiple threads. (rjung)
     * Update: Windows: Use non-default socket keepalive interval. (mturk)
     * Add: IIS: Add environment variables JKISAPI_PATH and JKISAPI_NAME.
       (mturk)
     * Add: Added socket_connect_timeout directive for setting the connect
       timeout for the socket. This enables to have low connection timeout
       but higher operational timeouts. (mturk)
     * Fix: AJP13: [CVE-2008-5519] Always send initial POST packet even if
       the client disconnected after sending request but before providing
       POST data. In that case or in case the client broke the connection in
       a middle of read send an zero size packet informing container about
       broken client connection. (mturk)
     * Add: AJP13: Added connection_acquire_timeout directive for setting the
       absolute timeout the worker will wait for a free endpoint. (mturk)
     * Update: Apache: Allow to set path parameter used when doing
       JkStripSession. (mturk)
     * Update: Refactor retries implementation and change semantics of
       retries attributes. (mturk)
     * Update: Status: Allow showing only a single member for a load
       balancer. (rjung)
     * Update: Status: Add display of seconds since last statistics reset and
       access and transfer rates. (rjung)
     * Add: AJP13: Add a configurable retry_interval time. (rjung)
     * Update: Documentation: Enhance description of connection_pool_size.
       (rjung)
     * Update: IIS: Refactor error page generation. (mturk)
     * Fix: IIS: SERVER_NAME variable can be the same for multiple different
       server instances if requests are handled according to the ip:port
       combination. Use INSTANCE_ID variable to which the request belongs
       instead. (mturk)
     * Add: Allow forwarding server error pages. This can be done on per-uri
       basis using new use_server_errors extension. (mturk)
     * Add: Added session_cookie and session_path for configuring default
       session identifiers. (mturk)
     * Update: Use max_packet_size also as TCP send and receive buffer size.
       (mturk)
     * Update: Apache: Do not allow Apache to start in multi-threaded mode if
       mod_jk was only build for single threaded server (prefork). (mturk)
     * Fix: 45812: Add done() service method that causes sending EOS bucket
       for Apache httpd 2.x. This allows filter chain to work properly.
       (mturk)
     * Add: Added connection_ping_interval, ping_timeout and ping_mode
       directives. (mturk)
     * Fix: Apache: Use correct ld flags provided by apxs when building
       module. Prevents some crashes on AIX for httpd 1.3 module. (rjung)
     * Fix: Documentation: "val" attribute numbering in status worker needs
       to start with 0 instead of 1. (rjung)
     * Update: Documentation: Remove JNI parameters from sample configuration
       in the workers common howto. (rjung)
     * Fix: 45026: For Apache httpd 2.x add "Unknown Reason" as the reason
       phrase, if we get an empty one from the backend. Otherwise httpd 2.x
       returns status 500. (rjung)
     * Fix: Build: Fix Cygwin build. (rjung)
     * Update: Documentation: Add info to docs, that variables sent via
       JkEnvVar are not listed in request.getAttributeNames(). (rjung)
     * Add: Add watchdog background thread for Apache 2.x and IIS doing
       internal maintenance (idle connection checks, backend probing). See
       JkWatchdogInternal (Apache) and watchdog_interval (IIS). (mturk)
     * Update: Change log level of some messages from error to info. (mturk)
     * Fix: Documentation: Fix docs for worker attribute "secret". (rjung)
     * Update: Detect correct plugin name for various web servers via
       additional preprocessor defines. (rjung)
     * Fix: LB: Do not put loadbalancer node in error state if there is
       opened channel. This fixes the bug when new connection fails due to
       busyness, causing opened connections fail stickyness. This brings back
       per-node busy counter and private state array for each request. We can
       mark the state as error for failover to work while still operating and
       reporting node as OK if there are opened working connections. (mturk)
     * Fix: 44738: Fix merging of JkOption ForwardURI* between virtual hosts.
       Patch contributed by Toshihiro Sasajima. (rjung)
     * Add: URI Map: Add extension attributes to uri worker map. Allowed are
       reply_timeout, active/disabled/stopped and fail_on_status. Usage
       currently only implemented for httpd and IIS. (rjung+mturk)
     * Fix: URI Map: Make dynamic reloading atomic and free memory not needed
       any longer. (rjung)
     * Add: Configure: Don't use post httpd 2.2.0 API functions when building
       with new --enable-api-compatibility configure switch. (rjung)
     * Fix: Apache: JkAutoAlias does not work in combination with JkMountCopy
       if there are no JkMount in virtual host. (rjung)
     * Update: LB: Optimize state macros to improve performance. (rjung)
     * Add: Apache: Allow dynamic setting of reply timeout using the
       environment variable JK_REPLY_TIMEOUT. (rjung)
     * Add: Status: Add manageability for ajp parameters of ajp workers and
       ajp lb members. (rjung)
     * Update: Status: Change parameter names of update action to make them
       more easily distinguishable from other parameters. (rjung)
     * Add: Status: Add ajp worker statistics also for workers, that are not
       lb members. (rjung)
     * Update: AJP: Refactor factories, move ajp13/ajp14 common parts into
       ajp_factory. (rjung)
     * Update: Status: Only sync shm worker config values of the workers for
       which we changed values. (rjung)
     * Fix: Status: Set lb_factor instead of distance. (rjung)
     * Update: Status: Minor layout changes, use drop down instead of
       multiple text links. (rjung)
     * Update: SHM: Use local copies of read mostly attributes of lb sub
       workers in lb and status worker. (rjung)
     * Update: Status: Add "dump" action to dump our initial configuration.
       (rjung)
     * Update: Status: Use property table to decide which cmd action uses
       which output elements. (rjung)
     * Update: Common: Include original configuration map in worker_env to
       make it available for workers, e.g. the status worker. (rjung)
     * Update: LB: Refactor "route" return for httpd note. Don't use a member
       of the worker_record, because that's not thread safe. (rjung)
     * Update: Common: Refactor "retries", remove from service and jk_worker,
       move into ajp worker instead. (rjung)
     * Update: SHM: Use distinct structs for lb and ajp13 in shm. Improves
       type safety and saves a few bytes. (rjung)
     * Update: SHM: Remove unused attributes. (rjung)
     * Update: SHM: Automatically determine shm size for all web servers.
       (rjung)
     * Update: SHM: Make open/attach logging consistent for all web servers.
       (rjung)
     * Update: Status: Include server local time in output. (rjung)
     * Fix: 44116: Fix handling of multiple JSESSIONID cookies. (rjung)
     * Fix: 37850: Use thread safe localtime_r where appropriate. (rjung)
     * Fix: Use thread safe strtok_r on more platforms, especially AIX.
       (rjung)
     * Update: Status: Improve XSS hardening. (rjung)
     * Update: 35303: Move initialization of service members with defaults
       from web server specific code to our generic jk_init_ws_service()
       function. (rjung)
     * Fix: 36385: Add missing prepost CPing/CPong directly after connect in
       case prepost CPing is used, but no connect CPing. (rjung)
     * Update: 37322: Apache: Enhance robustness of message formating in
       jk_error_exit(). (rjung)
     * Fix: 44147: Multiple load balancing workers problem. (rjung)

  Changes between 1.2.25 and 1.2.26

    Native

     * Fix: 42003: Allocate memory instead using fixed size from the stack.
       (mturk)
     * Fix: 43229: Load balancer does not do fail over after reply timeouts.
       (rjung)
     * Fix: JKStatus: Repair detailed Apache httpd version display. This was
       broken for httpd version 2.2.4+. (rjung)
     * Update: LB/AJP: Refactoring of jk_connect.c, jk_ajp_common.c,
       jk_lb_worker.c (rjung)
     * Fix: Configure: Repair broken apxs auto-detection. (rjung)
     * Update: Configure: Remove trace logging from compiled code via new
       --disable-trace configure switch. (rjung)
     * Update: Common: Maintain idle connections in decreasing (LRU) slot
       order. (rjung)
     * Update: Apache: Create JK_WORKER_ROUTE and JK_REQUEST_DURATION notes
       for access log even if no JkRequestLogFormat is set. (rjung)
     * Update: JKStatus: Enhance URI to worker map listing for Apache httpd.
       We now list maps for all virtual servers and not only the one, in
       which JKStatus itself was called. (rjung)
     * Update: JKStatus: Enhance URI to worker map listing. Update stale
       uriworkermap.properties immediately. (rjung)
     * Fix: 43873: Fix small memory leak occuring during httpd restart.
       (rjung)
     * Update: Common: Allow '*' for the worker name in exclusion rules
       (resp. JkUnMount) which will override all workers. (rjung)
     * Fix: 42038: Correct overlay of mounts and unmounts for IIS. (rjung)
     * Fix: 43684: Replace JkMountFile by JkMountFileReload in
       uriworkermap.properties docs. (rjung)
     * Update: Apache: Add new value "All" for JkMountCopy. (rjung)
     * Fix: 43516: Memory leak for Apache httpd module of size 8KB for every
       virtual host without JK directive after each restart. (rjung)
     * Update: Apache: Cleanup init and destroy of server configuration.
       (rjung)
     * Update: Apache: Remove global configuration items from per server
       configuration. (rjung)
     * Update: Apache: Remove unused attributes secret_key and
       automount/JkAutoMount. (rjung)
     * Update: Cleanup of jk_uri_worker_map. (rjung)
     * Update: Documentation: Small additions to JkShmFile documentation.
       Contributed by Gerhardus Geldenhuis. (rjung)
     * Fix: AJP13: Ignore flush packets before we received the response
       headers. (rjung)
     * Fix: Fix crash during startup when using worker configuration
       inheritance (attribute "reference") and log level debug. (rjung)
     * Fix: AJP13: Match header names exactly against pre defined constants.
       Avoid possible confusion with custom header names using a standard
       header name as a prefix. (rjung)
     * Fix: jkstatus: Fix correct parameter validation at JkStatusUpdateTask
       and JkStatusUpdateLoadbalancerTask ant tasks. Reported by Christian
       Mittendorf. (pero)

  Changes between 1.2.24 and 1.2.25

    Native

     * Update: IIS: Fix shm shutdown behaviour. (rjung)
     * Update: General: fail_on_status used in a load balancer can optionally
       do fail over without putting the failed worker in error state. (rjung)
     * Update: NSAPI: Improve build description for Unix. (rjung)
     * Update: NSAPI: Add initialization startup message containing JK
       version. (rjung)
     * Fix: General: Declare static functions as static. (jim)
     * Update: Documentation: Clarify fail_on_status behaviour. (rjung)
     * Fix: General: Do fail_on_status before returning the response headers.
       (rjung)
     * Update: NSAPI: Fix shm shutdown behaviour. (rjung)
     * Update: NSAPI: Set return status even if request ended with an error.
       (rjung)
     * Update: NSAPI: Allow using without shm_file on WIN32 and Netware.
       (rjung)
     * Fix: NSAPI: Fix Crash of nsapi for log level debug and unset
       refect_unsafe. (rjung)
     * Update: NSAPI: Improve Solaris and Linux Makefiles for nsapi build.
       (rjung)
     * Fix: Build: Improve pid_t type detection during configure on Solaris.
       (rjung)
     * Update: Build: Experimental build support for gcc on WIN32 and
       Netware. (fuankg)
     * Update: Build: Makefile optimizations for Apache httpd 1.3/Netware .
       (fuankg)
     * Fix: General: Fix missing flush bug introduced in 1.2.24. (rjung)

  Changes between 1.2.23 and 1.2.24

    Native

     * Update: Documentation: Improved workers.properties description in the
       reference guide. (rjung)
     * Update: Documentation: Add a HowTo about the various timeouts. rjung)
     * Update: Logging: add milliseconds to the default timestamp format, if
       we have gettimeofday(). (rjung)
     * Update: Apache: add milliseconds (%Q) and microseconds (%q) as
       possible JkLogStampFormat conversion specifiers. This does not use
       strftime(), but needs gettimeofday(). (rjung)
     * Update: IIS & Sun: Log service failures also, if return code is
       negative. (rjung)
     * Fix: 42849: Abort startup of Apache httpd 1.3 in case mod_jk
       initialization failed. We already do the same for Apache httpd 2.x.
       (rjung)
     * Fix: 42849: Refuse to operate with IIS in case the initialization
       failed. Instead requesting isapi_redirect.dll 500 will be returned to
       the user. This is as closest as it can get to Apache Httpd where we
       refuse to start the server in case of fatal initialization errors.
       (mturk)
     * Fix: Load Balancer: Fix a deadlock in lb worker, which was exposed on
       Solaris for threaded Apache MPMs. (rjung)
     * Update: Logging: handle LWP IDs as 32 Bit unsigned. Try to make it
       work, although pthread IDs are opaque. (rjung)
     * Update: JkStatus: Added manipulation of max_reply_timeouts. (rjung)
     * Update: LB, Status: Add feature max_reply_timeouts, to make lb
       tolerant against occasional long running requests. (rjung)
     * Update: JkStatus: Added OK/IDLE as the successor of N/A. (rjung)
     * Update: Status worker: Renamed runtime states. All states have a major
       state (OK or ERR) and a substate. Changed the name N/A to OK/IDLE.
       Added docs about the meaning of the states to the status worker page
       in the reference guide. No new states have been added to code. (rjung)
     * Update: Common: Add recovery options for recovering idempotent http
       methods HEAD and GET. (rjung)
     * Fix: Correct documentation for worker attributes retries and
       recovery_options. (rjung)
     * Fix: Make writing log lines and line endings more atomic. (rjung)
     * Update: Common: Refactored and unified jk_map_read_prop* and
       jk_map_load_prop* for all use cases. (rjung)
     * Update: Common/Apache/IIS/Netscape: Add an option to check decoded
       URLs for potentially malicious constructions. (rjung)
     * Update: IIS: Document auth_complete and uri_select. (rjung)
     * Update: Apache/IIS/Netscape: Change the default forwarding encoding to
       the new proxy method. (jfclere, rjung)
     * Update: Common: Optionally reencode URIs before forwarding to the
       backend. Based on the URI reencoding done bei httpd mod_proxy.
       (jfclere, rjung)
     * Update: Common: auto-detect correct print format for pid_t. This fixes
       at least compiler warnings on Solaris. (rjung)
     * Fix: 42608: Handle Content-length as unsigned 64Bit to allow for huge
       up- and downloads. (rjung)
     * Update: Apache: Add forwarding uri to debug log. (rjung)
     * Update: Docs: Clarify relation between worker names and jvmRoute for
       load balancing. (rjung)
     * Fix: Use initial zero timeout for jk_is_socket_connected. The
       resulting detection is the same but offers a huge performance increase
       with mod_jk. In most cases the Operating System does not favor the 1
       microsecond timeout, but it rather rounds that up to much higher value
       (frequency of interrupt timer which on most systems defaults to
       100Hz). Patch provided by David McLaughlin. (mturk)
     * Update: NSAPI: Check correct log file and shm file configuration
       during startup. (rjung)
     * Fix: NSAPI: Add support for the general options concerning retries,
       flushing and connection persistance. (rjung)
     * Fix: NSAPI: fix crashes due to use of mount attribute in
       workers.properties. Changed initialization order. (rjung)
     * Fix: Improved handling of libtool and discrepancies between CC env
       variable and CC used during apache build by configure script. (rjung)
     * Fix: Always build with thread support, unless flag --enable-prefork is
       set during for configure. (rjung)
     * Update: Use snprintf/vsnprintf from ap_snprintf.c for platforms other
       than Windows, which might lack snprintf/vsnprintf implementations when
       NOT build for Apache httpd 2.x/APR (e.g. Sub Web Server) or without
       using configure. (fuankg)
     * Update: Imported ap_snprintf() from Apache 1.3. (fuankg)
     * Fix: Fix incorrect log object cleanup during statup, leading to
       crashes at least on iSeries. (rjung)
     * Update: Add jk_stat() and jk_file_exists() as wrapper functions. i5/OS
       V5R4 expects filename in ASCII for fopen but requires them in EBCDIC
       for stat(). (hgomez)
     * Update: i5/OS (AS/400) V5R4 port where Apache 2.0 modules should now
       use UTF8. (hgomez)
     * Update: Docs: Add comments on i5/OS build for V5R4 and previous
       releases. (hgomez)

  Changes between 1.2.22 and 1.2.23

    Native

     * Update: [CVE-2007-0450] and [CVE-2007-1860]: Change the default value
       of JkOptions to ForwardURICompatUnparsed. The old default value was
       ForwardURICompat. This should make URL interpretation between Apache
       httpd and Tomcat consistent (prevent double decoding problems).
       (rjung)

  Changes between 1.2.21 and 1.2.22

    Native

     * Fix: Refactor line endings logging to make it correct for all
       platforms and webservers. (mturk)
     * Update: Added command line windows make files. (mturk)
     * Update: Allow fail_on_status directive to be multi line. (mturk)
     * Fix: 42076: Fix name of new option from ForwardCertChain to
       ForwardSSLCertChain as documented. (rjung)
     * Fix: Docs: Fix a couple of typos, change format of a few tables, fix
       links to news pages. (rjung)
     * Fix: Fix correct URL for TC 6 examples in new IIS rewrite.properties
       configuration example file. (rjung)
     * Fix: Add svn properties to several files. (rjung)
     * Update: Add TC 6 examples to uriworkermap.properties in config
       examples. (rjung)
     * Update: Allow multiple status codes for fail_on_status directive. The
       status codes can be delimited by space or comma characters. (mturk)
     * Update: IIS. Added pcre like regular expressions for url rewrite
       rules. (mturk)
     * Fix: 41922: Apache 1.3. Enable JkEnvVar. (mturk)
     * Update: Apache. Add --enable-flock configure parameter for explicit
       compilation of faster flock() system calls for OS supporting those
       calls. By default the fcntl system call for locking will be used that
       is a little bit slower but it can work on NFS mounted volumes as well.
       (mturk)
     * Fix: 41562: Add Debug logging for read from client in ISAPI
       Redirector. Contributed by Tim Whittington. (mturk)
     * Update: Apache. Add ForwardSSLCertChain JkOption. Contributed by
       Patrik Schnellmann. (mturk)
     * Fix: IIS. Do not forbid access to web-inf or meta-inf if there is no
       mapped worker. This allows to have resource with those names that are
       outside mapped contexts. (mturk)
     * Update: Apache. Use process id for creating shared memory name and
       delete shared memory and shared memory lock files on exit. (mturk)
     * Fix: IIS. Fix Keep-Alive regression introduced in 1.2.21. (mturk)
     * Update: Delete unused check for empty init_map during startup. (rjung)
     * Fix: 41770: Fix startup error if no JkWorkersFile is used. (rjung)
     * Update: Use JK_TRUE/JK_FALSE instead of OK/!OK as return values in
       init_jk(). (rjung)
     * Update: Minor adjustments to apache startup log messages (when to use
       STDERR, remove deprecated NOERRNO flag, shm warning and warnings for
       usage of default files). (rjung)
     * Update: Replace APR precompiler directive by httpd mpm_query to detect
       MPM threading. Add a debug log message about auto-detected pool size.
       (rjung)
     * Fix: Make MMN check easier to understand and a little more precise
       (for new ap_get_server_banner()/ap_get_server_description()). We use
       the new API only for Apache httpd 2.3. This way our binaries are not
       tightly coupled to a minor 2.0 version, and we don't use
       ap_get_server_banner() any way. (rjung)
     * Fix: Use the full description string ap_get_server_description()
       instead of the truncated info from ap_get_server_banner(), because
       this info gets used internally (status worker display and ajp14
       backend communication) and is not send back to the normal user.
       (rjung)
     * Fix: 41757: Document the "--enable-prefork" flag of configure. (rjung)
     * Update: Enhance log messages for failures when parsing attribute maps.
       (rjung)
     * Fix: Correct log message during worker initialization, in case remote
       host could not be resolved. We logged the default host name
       "localhost" instead of the configured one. (rjung)
     * Fix: 41770: Fix the second part of the bug: local_worker and
       local_worker_only is missing from the list of deprecated attributes
       (and not supported either), so prevents the web server from startup.
       (rjung)

  Changes between 1.2.20 and 1.2.21

    Native

     * Fix: [CVE-2007-0774]: A denial of service and critical remote code
       execution vulnerability. Caused by buffer overflow in
       map_uri_to_worker() when URL were longer that 4095 bytes. Reported by
       ZDI (www.zerodayintiative.com). Please note this issue only affected
       versions 1.2.19 and 1.2.20 of the Apache Tomcat JK Web Server
       Connector and not previous versions. Tomcat 5.5.20 and Tomcat 4.1.34
       included a vulnerable version in their source packages. Other versions
       of Tomcat were not affected.
     * Add: Check the worker. parameters and don't start if the parameter is
       not a valid one. (jfclere)
     * Add: 41439: Allow session IDs to get stripped off URLs of static
       content in Apache by adding JkStripSession directive (configurable per
       vhost). (mturk)
     * Add: Change semantics of empty defaults for JkEnvVar variables. Until
       1.2.19: not allowed. In 1.2.20: send variables as empty strings, if
       neither set to non empty in config, nor during runtime. Starting with
       1.2.21: If config has no second argument only send variable if set
       (even when set to empty string) during runtime. Allows good
       combination with condition attribute in tomcat access log. (rjung)
     * Fix: 41610: Fix incorrect detection of missing Content-Length header
       leading to duplicate headers. Contributed by Boris Maras. (rjung)
     * Fix: Better build support for SunONE (Netscape/iPlanet) webservers.
       (jim)
     * Add: Add warning if duplicate map keys are read and are not allowed,
       e.g. when parsing uriworkermap.properties. (rjung)
     * Fix: Don't concat worker names, if uriworkermap.properties has a
       duplicate pattern, instead overwrite the worker. (rjung)
     * Fix: Log deprecation message even in duplication case. (rjung)
     * Fix: uriworkermap.properties: Fix off-by-one problem when deleting URL
       mapping during reloading of uriworkermap.properties. (rjung)
     * Add: 41439: Allow session IDs to get stripped off URLs of static
       content in IIS (configurable). (rjung)
     * Add: 41333: Refactoring isapi_plugin configuration reading. (rjung)
     * Add: 41332: Add some more errno logging and unify the format. (rjung)
     * Add: JkStatus: Improved logging by adding status worker name to
       messages. Added messages to the recover worker action. (rjung)
     * Add: JkStatus: Refactoring searching for workers and sub workers.
       (rjung)
     * Add: 41318: Add configuration to make status worker user name checks
       case insensitive. (rjung)
     * Add: JkStatus: Add estimated time until next global maintenance to
       other mime types and adopt jkstatus ant task. (rjung)
     * Add: JkStatus: Show estimated time until next global maintenance.
       Change displayed time until next recovery to a min/max pair. (rjung)
     * Add: JkStatus: Allow a user of a read/write status worker to switch it
       to and from read_only mode temporarily. (rjung)
     * Fix: JkStatus: Do not show read/write commands in a read_only status
       worker. (rjung)
     * Add: JkStatus: Allow lb sub workers in error state to be marked for
       recovery administratively from the status worker. (rjung)
     * Add: Load Balancer: Do not try to recover multiple times in parallel.
       Use additional runtime states "PROBE" and "FORCED". (rjung)
     * Fix: JkStatus: Improve data synchronization between different
       processes. (rjung)
     * Fix: 41381: Fix segfault in feature fail_on_status (wrong order of log
       arguments). Patch by Juri Haberland. (rjung)
     * Fix: Use correct windows line endings for log file on WIN32 platform.
       (rjung)

  Changes between 1.2.19 and 1.2.20

    Native

     * Add: JkStatus Ant Task documentation page. (pero/rjung)
     * Add: JkStatus Ant Tasks: Add new tasks for update and reset. (pero)
     * Update: JkStatus Ant Tasks: Update for new xml status format. (pero)
     * Update: Allow integer and string values when setting
       enumeration/boolean attributes via status worker update action.
       (rjung)
     * Add: Docs: New reference guide page for status worker. (rjung)
     * Update: Docs: Renaming the config dir to reference and using the title
       Reference Guide in the docs. (rjung)
     * Update: Added retry_on_status for workers directive. (mturk)
     * Update: Status Worker: Add directive to make property prefix and
       good/bad rule configurable. (rjung)
     * Update: Status Worker: Omit lb members when att=nosw. (rjung)
     * Update: Status Worker: New command cmd=version for a short version
       output. (rjung)
     * Update: Status Worker: New output stype mime=prop produces property
       lists. (rjung)
     * Fix: Apache: Fix incorrect handling of JkEnvVar when Vars are set
       multiple times. (rjung)
     * Update: Renamed jvm_route to route. Deprecated jvm_route, but still
       use it as fallback when parsing the worker configuration. (rjung)
     * Update: IIS: Make uriworkermap file reload check interval
       configurable. (mturk)
     * Update: Apache: Make uriworkermap file reload check interval
       configurable. (rjung)
     * Update: Status Worker: Add directives for customizing the XML output
       (ns, xmlns, doctype). (mturk)
     * Add: Docs: New page with description of uriworkermap. (rjung)
     * Update: Docs: Added short description of max_packet_size to worker
       reference. (rjung)
     * Update: Status Worker: All functions accessible also for xml and txt
       mime types (list, show, update, reset). (rjung)
     * Update: Status Worker: New global health indicators for load balancers
       named bad (error, recovering or stopped), degraded (busy or disabled)
       and good (the rest, active and OK or N/A). (rjung)
     * Update: Status Worker: New edit page, to change one attribute for all
       members of a load balancer. (rjung)
     * Update: Status Worker: Standard logging for status worker. (rjung)
     * Update: Status Worker: code refactoring. (rjung)
     * Update: Status Worker: New attribute user (list) denies access, if the
       request user in the sense of remote_user is not in this list. Empty
       list = no deny (rjung)
     * Update: Status Worker: New attribute read_only disables the parts of
       the status worker, that change states and configurations. (rjung)
     * Fix: 36121: Don't change main uri when mod_jk serves included uri.
       (markt)
     * Update: Apache VHosts: Merge JkOptions +base - -base + +vhost -
       -vhost. (rjung)
     * Update: Apache Docs: Adding requirements, context information, default
       values and inheritance rules to the Apache config documentation.
       (rjung)
     * Update: Status Worker: Add source type to status worker, remove the
       redundant "context" column in the map listing (context=uri). (rjung)
     * Update: uriworkermap: On reload of the file, all old entries from the
       previous file version get deleted, before the new ones are being read.
       (rjung)
     * Fix: Keep normal maps and exclusion maps internally separate. Don't
       treat them as the same when adding a rule. (rjung)
     * Update: Status Worker: Display mapping rules also for non-lb workers
       and in global view. (rjung)
     * Update: Apache VHosts: Use the vhost log files instead of the main
       log. (rjung)
     * Update: Apache VHosts: Allow individual timestamp formats by
       refactoring the formatting method. (rjung)
     * Update: Apache VHosts: Adding all missing config items to the virtual
       host level. Don't overwrite the settings from the global server, but
       inherit them in case they are not set in the virtual host. (rjung)
     * Update: Apache: remove unnecessary function names from log messages.
       (rjung)
     * Update: Apache: add a default log file location and a message, if the
       default gets used. (rjung)
     * Update: Apache: add missing JK_IS_DEBUG_LEVEL() (rjung)
     * Update: Apache VHosts: Allow JkWorkersFile, JKWorkerProperty,
       JkShmFile and JkShmFileSize only in global virtual server. (rjung)
     * Update: Add some more jk_close_socket() and reduce log level for some
       info messages. (rjung)
     * Update: Load Balancer: Added the Sessions strategy. Contributed by
       Takayuki Kaneko. (rjung)
     * Update: Docs: Minor enhancements and syncing with more recent
       versions. (rjung)
     * Fix: 40997: Separate uri mappings from their '!' counterpart when
       checking for duplicates in uriworkermap reloading. (rjung)
     * Fix: 40877: Make sure the shared memory is reset on attach for
       multiple web server child processes. (mturk)
     * Update: IIS: Added shm_size property to be able to deal with over 64
       workers configurations. (mturk)
     * Update: IIS: Increase default thread count to 250, so its the same as
       Apache Httpd default configuration. (mturk)
     * Fix: 40966: Fix socket descriptor checks on windows. (mturk)
     * Fix: 40965: Initialize missing service parameters. (mturk)
     * Fix: 40938: Fix releasing of rewrite map. Thanks to Chris Adams for
       spotting that. (mturk)
     * Update: Apache: Added +FlushHeader JkOptions. (mturk)
     * Update: Added explicit flush when AJP body packet size is zero.
       (mturk)
     * Fix: 40856: Fixing case sensitivity bug in URL mapping. (rjung)
     * Fix: 40793: Documentation: Improvements to Apache HowTo provided by
       Paul Charles Leddy. (markt)
     * Fix: 40774: Fixing wrong recursion termination. This one restricted
       the "reference" feature unintentionally to 20 workers. (rjung)
     * Fix: 40716: Adding "reference" feature to IIS and Netscape. (rjung)
     * Fix: Documentation: Corrected SetEnvIf syntax in JK_WORKER_NAME
       example. (rjung)
     * Fix: Documentation: Added forgotten STATE and ACTIVATION notes for
       load balancer logging in Apache. (rjung)
     * Update: Apache: Use instdso.sh instead libtool: libtool does not work
       on HP-UX for example. (jfclere)

  Changes between 1.2.18 and 1.2.19

    Native

     * Update: Docs: Add SetHandler and new env var to Apache config docs.
       (rjung)
     * Update: Apache 1.3: Backport "no-jk" feature. (rjung)
     * Update: Apache: Add an environment variable to make SetHandler
       "jakarta-servlet" more useful. The variable is JK_WORKER_NAME, but can
       be changed by the new directive JkWorkerIndicator. (rjung)
     * Fix: LB: Don't use single worker shortcut, if the single worker is
       being diabled. (rjung)
     * Fix: Status worker: Add short explanation of activation and error
       states to legend. (rjung)
     * Fix: Docs: Add meaning of zero timeout values for various timeouts in
       workers.properties. (rjung)
     * Fix: LB: Cleanup of Mladens forced recovery. (rjung)
     * Fix: LB: Do not change lb_value for recovering workers to max, if we
       are using BUSYNESS method. (rjung)
     * Fix: Apache: Since 1.2.14 mod_jk failed to detect client abort.
       (rjung)
     * Fix: Docs: Corrected description of JkEnvVar. (rjung)
     * Fix: Solaris: Detect filio.h in configure to make the new connection
       detection build on solaris (r432825). (rjung)
     * Update: Add feature to force the recovery of workers that are member
       of loadbalancer if all the members are in error state. This fixes the
       time gap where 503 was returned caused by recovery_timeout although
       the backend was ready to handle the requests. (mturk)
     * Update: Docs: Seperate deprecated directives in their own table.
       (rjung)
     * Update: Docs: Allow "-" and "_" in worker names. (rjung)
     * Update: Allow multiple lines with attributes "balance_workers" and
       "mount". (rjung)
     * Fix: Make jk_is_some_property match more precisely. (rjung)
     * Update: JkStatus: Make refresh interval changeable. (rjung)
     * Fix: JkStatus: Adjust display of recover time wrt. global maintenance.
       (rjung)
     * Update: LB: Resetting worker state from OK to NA, if worker has been
       idle too long. (rjung)
     * Fix: Avoid compiler warnings concerning the use of lb_*_type arrays.
       Use functions instead. (rjung)
     * Update: Added %R JkRequestLogFormat option for Apache 1 and Apache 2.
       (mturk)
     * Update: Allow changing jvm Route from status manager. (mturk)
     * Fix: Do not retun 400 if Tomcat fails in the midle of the post
       request. Return 500 insted. (mturk)
     * Update: LB: Combine ok/error/recovering/busy runtime states into a
       single scalar. (rjung)
     * Update: LB: Combine active/disabled/stopped configuration states into
       a single scalar. (rjung)
     * Update: LB: Add several Apache notes to enable standard logging for
       load balancer results. (rjung)
     * Update: LB: Reorganisation of the main load balancer service loop.
       (rjung)
     * Update: Implement hierarchical worker configuration via attribute
       "reference". (rjung)
     * Update: Log deprecated properties. (rjung)
     * Fix: IIS: Fix simple_rewrite for the cases where the rewritten url is
       larger then the original one. (mturk)
     * Update: New JkOption "DisableReuse" to disable connection persistence.
       (jim)
     * Update: LB: Move sessionid retrieval out of get_most_suitable_worker
       into service. (rjung)
     * Update: Code cleanup for all service methods (use TRACE,
       JK_LOG_NULL_PARAMS, null pointer checks). (rjung)
     * Update: JKSTATUS: add refresh link. No refresh for updates. Redirect
       to list view after update. (rjung)
     * Update: Add new hook add_log_items into servers. (rjung)
     * Update: APACHE httpd: Rename apache logging notes. (rjung)
     * Update: LB: Rename lock and method constants. Add constants for
       defaults. (rjung)
     * Fix: Default log level should be INFO and not DEBUG. Default log level
       should be the same for all server types. (rjung)
     * Fix: Make rewrite_rule_map and log_level as non mandatory directives
       for isapi_redirect. (mturk)
     * Fix: 40107: Rewrite is_socket_connected function. Non blocking socket
       is not used any more. (mturk)
     * Update: Allow building with VS2005 without too many warnings. (mturk)
     * Fix: Decide by MMN, which piped log API we should use. mod_jk 1.2.18
       broke compilation with Apache 1.3 pre 1.3.28. (rjung)

  Changes between 1.2.17 and 1.2.18

    Native

     * Fix: Using socklen_t in getsockopt. Also introducing jk_sock_t.
       (mturk)
     * Update: Allow recovery wait time below 60 seconds (new minimum is 1
       second). (mturk)

  Changes between 1.2.16 and JK 1.2.17

    Native

     * Fix: Fix hanging jk status worker when certain attributes are being
       updated due to double locking. (rjung)
     * Update: Allow JkMount to behave like uriworkermap.properties by
       parsing pipe symbol as two directive marker. (mturk)

  Changes between 1.2.15 and JK 1.2.16

    Native

     * Update: Added simple rewrite capability for IIS. Although simple it
       will fulfill most needs. (mturk)
     * Update: Added RECOVER_ABORT_IF_CLIENTERROR recovery_option that closes
       the connection if client connection is broken during the request.
       (mturk)
     * Update: Renamed cache_timeout directive to connection_pool_timeout.
       (mturk)
     * Update: Added connection_pool_minsize directive. (mturk)
     * Update: Deprecate recycle_timeout directive. (mturk)
     * Update: Corrected some HTML syntax bugs in output of status worker.
       (rjung)
     * Update: Added the refresh=n parameter to the status worker. It will
       update the display every n seconds. (rjung)
     * Update: Balancer: Add attribute distance to balanced workers to
       express preferences between workers. (rjung)
     * Update: Balancer: Add attribute jvm_route to balanced workers to be
       able to use the same target in different balancers. (rjung)
     * Update: Status: Add lb_mult to status. (rjung)
     * Update: Balancer: Make different balancing strategies work in a
       similar way (use lb_value, use decay during global maintenance, use
       integer factors for weights. (rjung)
     * Update: Balancer: Improve locking. (rjung)
     * Update: Balancer: Workers start slower after recovering. (rjung)
     * Update: Balancer: Make different balancing strategies work in a
       similar way (use lb_value, use decay during global maintenance, use
       integer factors lb_mult for weights). (rjung)
     * Update: Balancer: Move recovery check to global maintenance. (rjung)
     * Update: Balancer: Add global maintenance method, that is called in
       only one process. (rjung)
     * Update: Extend our use of autoconf to find a 32Bit and a 64Bit
       unsigned type and their printf formats. (rjung)
     * Update: Logging: piped loggers for JkLogFile and Apache 1.3. (rjung)
     * Update: Logging: Add PID to log lines for each log level apart from
       REQUEST. (rjung)
     * Update: Logging: flush buffered logs to keep lines in correct order.
       Output final newline together with log message. (rjung)
     * Update: Reducing shm size. (rjung)
     * Update: Only log removing of old worker, when we actually do it.
       (rjung)
     * Fix: 37469: Fix shared memory close for forked childs. The shared
       memory will be closed by the parent process. (mturk)
     * Fix: 37332: Fix potential misuse of buffer length with snprintf
       functions. (mturk)
     * Fix: 38859: [CVE-2006-7197] Protect mod_jk against buggy or malicious
       AJP servers in the backend. Patch provided by Ruediger Pluem. (mturk)
     * Fix: 38889: Use worker map sorting depending on the path elements, to
       comply with Servlet spec. Patch provided by Steve Revilak. (mturk)
     * Update: 36138: Added Busyness lb method. Patch provided by Chris
       Lamprecht. (mturk)
     * Fix: Fix pessimistic locking mode. The patch correctly handles the
       burst load, by syncing the access to the shared memory data. (mturk)
     * Fix: 38806: Reclycle worker even if it is disabled. This fixes
       hot-standby workers in error state. (mturk)
     * Fix: 37167: Allow building with BSD-ish like make. (mturk)
     * Fix: ISAPI plugin (isapi_redirect.dll) did not provide correct request
       data for IIS to include in the IIS log. (markt)

  Changes between 1.2.14 and 1.2.15

    Native

     * Fix: Fix AJP13 Cookie2 parsing. Cookie2 was always send as Cookie.
       Patch provided by Andre Gebers. (mturk)
     * Fix: 35862: NSAPI plugin attempts to read freed memory and attempts to
       dereference a null pointer. Patch provided by Brian Kavanagh. (markt)

  Changes between 1.2.13 and 1.2.14

    Native

     * Fix: Fix lb for worker mpm's with cachesize set to lower number then
       ThreadsPerChild is. If retries is set to value larger then 3 sleep for
       100 ms on each attempt. This enables to tune the connection cache, and
       serialize incoming connections instead returning busy if connection
       count is larger then cachesize. (mturk)
     * Fix: 36525: Solaris core dump. (mturk)
     * Fix: 36102: Worker actions do not persist. (mturk)
     * Fix: 35864: Status worker doesn't list workers. Patch provided by
       Martin Goldhahn. (mturk)
     * Fix: 35809: JkMountCopy don't work for Apache 2.0 Patch provided by
       Christophe Dubach. (mturk)
     * Fix: 35298: Multiple JK/ISAPI redirectors on a single IIS site are not
       supported Patch provided by Tim Whittington. (mturk)

  Changes between 1.2.12 and 1.2.13

    Native

     * Fix: 34397: Emergency was handled as Error. (jfclere)
     * Fix: 34474: // in URL were not handled correctly with Apache-1.3.
       (jfclere)
     * Fix: Use 64 bits int for transferred/read bytes.
     * Update: Added JkOptions +FlushPackets used to optimize memory usage
       when sending large data. (mturk)
     * Update: Added lock directive for load balancer that allows more
       acurate load balancing in case of burst load. (mturk)
     * Update: Added worker.maintain directive to allow customizing default
       10 second timeout. On busy servers this value needs to be set on
       higher value. (mturk)
     * Fix: Fix for NetWare compiler to deal with different types between
       AP13 and AP2 SDKs. (fuankg)
     * Update: Emit much more legible user.dmp crash analysis output for
       WIN32. (wrowe)
     * Fix: 34558: Fix first failover request. (mturk)

  Changes between 1.2.11 and 1.2.12

    Native

     * Update: Added ForwardLocalAddress JkOptions flag for passing local
       instead remote address. Useful for remote addr valve. (mturk)
     * Fix:Fix that worker does not get used, when stopped flag is set to
       true. (pero)
     * Update: Add loadbalance default worker secret attribute to the
       documentation (pero)

  Changes between 1.2.10 and 1.2.11

    Native

     * Fix:Backport SC_M_JK_STORED from JK2 for passing arbitrary methods
       instead failing the request. (mturk)
     * Fix:Added missing SEARCH and ACL http methods. (mturk)
     * Update: Add worker secret attribute to the documentation (pero)
     * Update: Add a stopped flag to worker configuration. Set flag to true
       and the complete traffic to the worker will be stopped. Also update
       the Ant JkStatusUpdateTask at Tomcat 5.5.10 release. Only usefull in a
       replicated session cluster.(pero)
     * Update:Added worker maintain function that will maintain all the
       workers instead just the current one. This enables to recycle the
       connections on all workers. (mturk)
     * Update:Use shutdown when recycling connections instead hard breaking
       the socket. (mturk)
     * Update:Add unique directives checking. The directives if unique are
       now overwritten instead concatenated. (mturk)
     * Update:Allow multiple worker.list directives. (mturk)
     * Fix: 34577: For IIS log original request instead loging the request
       for ISAPI extension. (mturk)
     * Fix: 34558: Make sure the returned status codes are the same for ajp
       and lb workers. (mturk)
     * Fix: 34423: Use APR_USE_FLOCK_SERIALIZE for setting log lock on
       platforms like FreeBSD. Patch provided by Allan Saddi. (mturk)
     * Fix: 33843: Fix obtaining LDFLAGS that were used for building Apache
       HTTPD. Patch provided by Beat Kneubuehl. (mturk)
     * Fix: 34358: Enable load balancer method configuration. (glenn)
     * Fix: 34357: In some situations Apache 2 mod_jk could segfault when the
       JkAutoAlias directive is used. (glenn)
     * Update: Add --enable-prefork to the documentation (pero)
     * Update:Update tomcat_trend.pl for new error log string formatting.
       (glenn)

  Changes between 1.2.8 and 1.2.10

    Native

     * Update:Set default shared memory to 64K instead 1M. (mturk)
     * Fix:Do not mark the worker in error state if headers are larger then
       AJP13 limit. (mturk)
     * Update: On iSeries you should use the latest PTF for Apache 2.0 (which
       is now 2.0.52) and ad minima SI17402/SI17061 or cumulative including
       them. (hgomez)
     * Update: Change the xml status format to xml attribute syntax (pero)
     * Fix: 33248: Fix builds where apxs defines multiple directories for APR
       includes. (mturk)
     * Fix: 32696: Return 404 instead 403 when WEB-INF is requested to comply
       with Servlet spec. (mturk)
     * Update:Added ANT task for managing jkstatus. (pero)
     * Update: If socket_timeout is set, check if socket is alive before
       sending any request to Tomcat. (mturk)
     * Update: Added JkMountFile for Apache web servers. This file can
       contain uri mappings in the form (/url=worker), and is checked for
       updates at regular 60 second interval. (mturk)
     * Update: Added status worker for managing worker runtime data using web
       page. (mturk)
     * Update: Added load balancer method directive that is used for setting
       the algorithm used for balancing workers. Method can be either Request
       (default) or Traffic. (mturk)
     * Update: Added shared memory to allow dynamic configuration. Shared
       memory is needed only for unix platform and web servers having
       multiple child processes. For Apache web server two new directives has
       been added (JkShmFile and JkShmSize). (mturk)
     * Update: Added textupdate mode to status worker to handle remote
       updates from ant tasks.(pero)
     * Fix: 33562: Fix Reply_timeout when recovery_options is larger than 1.
       Patch provided by Takashi Satou. (mturk)
     * Fix: 33308: Fix segfaults when ForwardDirectories is enabled with
       Apache 1.3

  Changes between 1.2.7 and 1.2.8

    Native

     * Update: Allow anyone to debug and diagnose stack dumps using windbg or
       any other debugging tool, and (if they add the .pdb files to their
       installation) to make sense of dr watson logs. Patch provided by
       William A. Rowe (wrowe)
     * Fix: Fix in_addr_t usage by using the real struct ignoring typedef.
       Patch provided by William A. Rowe (wrowe)
     * Fix: Fix url rewriting by restoring the in place uri from which the
       jsessionid was removed. (mturk)
     * Update: Make load balancer algorithm thread safe by introducing mutex
       to the load balancer worker. (mturk)
     * Fix: Fix sending error pages for IIS to client by adding Content-Type
       header using correct api function call. (mturk)
     * Fix: 32696: Prevent IIS from crushing when web-inf url was requested.
       (mturk)
     * Update: Use default cachesize for servers that support discovering the
       number of threads per child process. (mturk).
     * Fix: Fix Apache content-length header parsing using case insensitive
       compare. (billbarker)
     * Fix: Fix parsing AJP headers using case insensitive compare. (mturk)
     * Fix: Use infinite socket timeout if socket_timeout is set to zero or
       less then zero. (mturk)
     * Update: Change balanced_workers to balance_workers but keep backward
       compatibility preserving the old directive. (mturk).
     * Fix: Fix ajp initialization for workers with cache_size set to zero.
       (mturk)
     * Update: 32317: Making mod_jk replication aware (Clustering Support).
       Patch provided by Rainer Jung. (mturk).
     * Fix: 31132: Core dump when JkLogFile is missing from conf. (mturk)

  Changes between 1.2.6 and 1.2.7

    Native

     * Update: Added new property named recover_time that can be used to
       change the default 60 second recover time. (mturk)
     * Update: Added custom retries for worker, so we don't depend on default
       setting. If set to a number grater then 3, it will sleep for 100ms on
       retry greater then 3 and then try again. (mturk)
     * Update: Added JkWorkerProperty directive that enables omiting
       workers.properties file. For example: JkWorkerProperty
       worker.ajp13a.port=8009. (mturk)
     * Fix: Check all JSESSIONID cookies for a valid jvmRoute. If you have
       multiple Tomcats with overlapping domains, then you can get multiple
       cookies without a defined order. This will route correctly as long as
       the different domains don't have any Tomcats in common. (billbarker)
     * Update: Added JkUnMount directive for negative mappings that works as
       opposite to JkMount directives. It is used for blocking of particular
       URL or content type. (mturk)
     * Update: Added wildchar match uri mappings. One can now use JkMount to
       map /app/*/servlet/* or /app?/*/*.jsp. (mturk)
     * Update: Rewrite the logging by adding Trace options. (mturk)
     * Update: Added socket_timeout property that sets the timeout for the
       socket itself. (mturk)
     * Fix: Changed socket_timeout property to recycle_timeout. This better
       explains what the directive actually does. (mturk)
     * Fix: Changed the load balancer algorithm. The idea behind this new
       scheduler is the following: lbfactor is how much we expect this worker
       to work, or the worker's work quota. lbstatus is how urgent this
       worker has to work to fulfill its quota of work. We distribute each
       worker's work quota to the worker, and then look which of them needs
       to work most urgently (biggest lbstatus). This worker is then selected
       for work, and its lbstatus reduced by the total work quota we
       distributed to all workers. Thus the sum of all lbstatus does not
       change.(*) If some workers are disabled, the others will still be
       scheduled correctly. (mturk)
     * Fix: Fix iis redirector that was figuring .properties file on each
       request. (mturk)
     * Fix: Start fixing 64/32 bit compatibility issues. (mturk)

  Changes between 1.2.5 and 1.2.6

    Native

     * Fix: Fix POST Recovery problems in LB mode. (hgomez)
     * Add: Add CPING/CPONG support to avoid problems with hang tomcats.
       (hgomez)
     * Update: Make POST recovery in LB configurable. (hgomez)
     * Update: Update to Apache License 2.0. (hgomez)
     * Add: For Apache 2.0, when the env var no-jk is present, mod_jk didn't
       handle request (declined) and as such dont forward requests to tomcats
       even if URL match. To be used with SetEnvIf or BrowserMatch directives
       for example to exclude some URL/URI or Browser (hgomez).
     * Fix: Add a fix for iSeries (AS/400) which use XOPEN/Unix98 APIs and
       need sa_len to be set when calling connect(), it will resolve the
       error EINVAL in jk_connect. (hgomez)

  Changes between 1.2.4 and 1.2.5

    Native

     * Fix: Fix a thread safe bug when mapping URI's. (billbarker)
     * Fix: Fix a thread safe bug when resolving worker host name when using
       mod_jk with Apache 2 and the worker MPM. (hgomez)
     * Fix: Remove an unnecessary error message when connections to all load
       balanced workers fail. (glenn)
     * Fix: When mod_jk cannot connect to a worker include the name of the
       worker in the error message. This is especially helpful when you are
       using load balanced workers. (glenn)
     * Fix: Fix problem with mod_jk.log getting opened multiple times for
       Apache 2. Only one mod_jk.log can be configured. (glenn)
     * Fix: Fix Apache 2 connector so that DirectoryIndex works for an
       index.jsp page if JkOptions ForwardDirectories was configured.
       (hgomez)
     * Fix: Fix exposure of JSP source if a //path/to.jsp URL was requested
       in Apache 1.3 and Apache 2.0 connector. (billbarker)

  Changes between 1.2.3 and 1.2.4

    Native

     * Add: Fix use of libtool for Apache mod_jk builds with more recent
       versions of Apache 2. (jfclere)
     * Fix: Use reentrant version of strtok() for web server's which use
       threads. This fixes a thread safe bug under Apache 2 and the worker
       MPM. (glenn)
     * Fix: Fix the Apache 2 mod_jk hook priority so that mod_jk works well
       with both mod_alias and mod_dir. (glenn)

  Changes between 1.2.2 and 1.2.3

    Native

     * Add: Add the ability to configure JkLog to pipe its log output to an
       executable such as Apache rotatelogs or cronolog. Apache 2.0 only.
       (glenn)
     * Add: Add JkAutoAlias to Apache 2.0. (glenn)
     * Update: Apache 2/1.3, if Tomcat returns an error but not content, let
       Apache handle processing the error returned by Tomcat. (glenn)
     * Add: Added the load balancer sticky_session property. If set to 0
       requests with servlet SESSION ID's can be routed to any Tomcat worker.
       Default is 1, sessions are sticky. (glenn)
     * Fix: Cleaned up detection and reporting of aborted client connections.
       This cleanup also makes sure that mod_jk does not pass any requests on
       to Tomcat if the remote client aborted its connection. (glenn)
     * Fix: Fixed a bug in Apache 2.0 which caused a POST request forwarded
       to Tomcat to fail if it generated SSI directives which were post
       processed by mod_include. (glenn)
     * Fix: Fixed a bug in JkRequestLogFormat when printing the request URI
       that could cause a URI with hex escapes sequences to be formatted
       wrong. (glenn)

  Changes between 1.2.1 and 1.2.2

    Native

     * Update: tomcat_trend.pl updated script to support changed logging of
       aborted requests. (glenn)
     * Fix: jk set correctly the content-type in Apache 2.0, making it ready
       to works with mod_deflate and AddOutputFilterByType. (hgomez)
     * Fix: jk will check result of get_endpoint and handle a failure. This
       call can fail if the allocation for the endpoint fails because of low
       memory conditions causing a dereference of NULL when we try and access
       the endpoint. (mmanders)

  Changes between 1.2.0 and 1.2.1

    Native

     * Fix: 14282: Don't send initial chunk for chunked encoding. (costin)
     * Add: Add perl scripts for analyzing mod_jk logs and generating
       graphs/reports. (glenn)
     * Fix: Make JK honor the CanonicalHost directive. (hgomez)
     * Fix: Log cleanup. (costin)
     * Fix: Fix typos in jk xdocs/docs. (hgomez)
     * Fix: Add JkRequestLogFormat to Apache 2.0. (hgomez)
     * Fix: Final patches to make JK iSeries compliant. (hgomez)

  JK 2

   JK2 has been put in maintainer mode and no further development will take
   place. The reason for shutting down JK2 development was the lack of
   developers interest. Other reason was lack of users interest in adopting
   JK2, caused by configuration complexity when compared to JK.

   Copyright © 1999-2024, The Apache Software Foundation
